unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, CGIXapp, Winsock;

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem2Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem3Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem4Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem5Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem6Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
    function ZobrazStranku(pozice:integer):string;
    function ZrusPrebytecne(Contents:TStringList):boolean;
    function LocalIP():string;
  public
    { Public declarations }
  end;
  KosikPolozka = packed record
      Nazev:string;
      Pocet:integer;
      Cena:integer;
  end;

var
  WebModule1: TWebModule1;
  Poloha:integer;
  const Polozky: array [1..23] of string =('Afterburner Enhancer',
                                   'Repair Droid',
                                   'Gun Coolant',
                                   'Shield regenerators',
                                   'Warp Shield',
                                   'BSE',
                                   'Nuke''em Bomb',
                                   'Signal Filter',
                                   'Mines',
                                   'Decoys',
                                   'Stream Laser',
                                   'Volt Laser',
                                   'Flux Beam',
                                   'Mass Ion Cannon',
                                   'Kraven Mk II',
                                   'Snipe Missile',
                                   'Brute Missile',
                                   'Python Missile',
                                   'Disrupter Missile',
                                   'Banshee Missile',
                                   'Proximity Missile',
                                   'Stingray Torpedo',
                                   'Hellraiser Torpedo');
  const Pocty: array [1..23] of integer = (3,2,4,3,1,2,1,1,3,2,2,1,2,1,0,1,2,1,1,1,1,1,1);
  const Obrazky: array [1..23] of string =('afterburner',
                                           'auto_repair',
                                           'coolant',
                                           'shield_regenerator',
                                           'warp_shield',
                                           'bse',
                                           'nuke''em',
                                           'signal_filter',
                                           'mines',
                                           'decoys',
                                           'stream_laser',
                                           'volt_laser',
                                           'flux_beam',
                                           'mass_ion_cannon',
                                           'none',
                                           'snipe_missile',
                                           'brute_missile',
                                           'python_missile',
                                           'disrupter_missile',
                                           'banshee_missile',
                                           'proxomity_missile',
                                           'stingray_torpedo',
                                           'hellraiser_torpedo');
  const Cisla: array [1..4] of string = ('','Mk II','Mk III','Mk IV');
  const Cena: array [1..23,1..4] of integer=((4000,8000,16000,0),
                                             (8000,16000,0,0),
                                             (6000,12000,24000,48000),
                                             (7000,14000,25000,0),
                                             (25000,0,0,0),
                                             (12000,18000,0,0),
                                             (4000,0,0,0),
                                             (6000,0,0,0),
                                             (150,200,350,0),
                                             (400,800,0,0),
                                             (600,7000,0,0),
                                             (3000,0,0,0),
                                             (5000,8000,0,0),
                                             (10000,0,0,0),
                                             (0,0,0,0),
                                             (100,0,0,0),
                                             (150,200,0,0),
                                             (225,0,0,0),
                                             (250,0,0,0),
                                             (205,0,0,0),
                                             (210,0,0,0),
                                             (500,0,0,0),
                                             (1000,0,0,0));

implementation

{$R *.DFM}

procedure TWebModule1.WebModule1WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var TmpStream:TFileStream;
//    Kosik:KosikPolozka;
    Contents:TStringList;
    i,j,pozice,celkem:integer;
    FileName:string;
begin
     Response.SetCustomHeader('Content-Type','text/html');
     FileName:='Hosts\'+Request.Host;
     Contents:=TStringList.Create;
     try
        if FileExists(FileName)=True then
           TmpStream:=TFileStream.Create(FileName,fmOpenReadWrite)
        else
           TmpStream:=TFileStream.Create(FileName,fmCreate);
        try
           Request.ExtractContentFields(Contents);
           TmpStream.Position:=TmpStream.Size;
           for i:=0 to 2 do
               Contents.Strings[i]:=Copy(Contents.Strings[i],7,Length(Contents.Strings[i])-6);
           for i:=1 to 23 do begin
               if copy(Polozky[i],1,3)=copy(Contents.Strings[0],1,3) then begin
                  if length(Polozky[i])=length(Contents.Strings[0]) then
                     Contents.Strings[2]:=inttostr(strtoint(Contents.Strings[1])*Cena[i,1]);
                  if pos(Cisla[2],Contents.Strings[0])>0 then
                     Contents.Strings[2]:=inttostr(strtoint(Contents.Strings[1])*Cena[i,2]);
                  if pos(Cisla[3],Contents.Strings[0])>0 then
                     Contents.Strings[2]:=inttostr(strtoint(Contents.Strings[1])*Cena[i,3]);
                  if pos(Cisla[4],Contents.Strings[0])>0 then
                     Contents.Strings[2]:=inttostr(strtoint(Contents.Strings[1])*Cena[i,4]);
                  pozice:=i;
                  break;
               end;
           end;
           Contents.SaveToStream(TmpStream);
        finally
           TmpStream.Free;
        end;
        Contents.Clear;
        Contents.LoadFromFile(FileName);

//        repeat
//        until not ZrusPrebytecne(Contents)=True;

        Response.Content:='<html><head><title>V.O.D. - Nkupn kok</title></head><body background="/cgi-bin/images/background.gif">'+
                          '<h2><font color=#ff00ff>V nkupn kok obsahuje:</font></h2>'+
                          '<table width=100%><tr><i><b>'+
                          '<td align=left width=70%><font color=#00ff00>Nzev zbo</font></td>'+
                          '<td align=center width=10%><font color=#00ff00>Mnostv</font></td>'+
                          '<td align=center width=20%><font color=#00ff00>Cena</font></td></b></i></tr>';

        celkem:=0;
        for i:=0 to (Contents.Count-1) div 3 do begin
            Response.Content:=Response.Content+
                          '<tr><td align=left><font color=#ffff00>'+Contents.Strings[i*3]+'</font></td>'+
                          '<td align=center><font color=#f0f0f0>'+Contents.Strings[i*3+1]+'<font></td>'+
                          '<td align=right><font color=#ff00aa>'+Contents.Strings[i*3+2]+' K</font></td></tr>';
            celkem:=celkem+strtoint(Contents.Strings[i*3+2]);
        end;
        Response.Content:=Response.Content+
                          '<tr><td></td>'+
                          '<td align=right><font color=#00ffff><b>Cena celkem</b></font></td>'+
                          '<td align=right><font color=#00ffff><b>'+inttostr(celkem)+' K</b></font></td></tr>'+
                          '</table><hr><center><font color=#f0f0ff>Zpt na: </font><form method="POST" action="/cgi-bin/DiplomkaCGI.exe"><p><input type="SUBMIT" name="posun" value="'+Polozky[pozice]+'"></p></form></center>'+
                          '</body></html>';

     finally
        Contents.Free;
     end;
end;

procedure TWebModule1.WebModule1WebActionItem2Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var i,posun:integer;
    Content:string;
begin
     Content:=Request.Content;
     if length(Content)=0 then
        posun:=0
     else begin
        for i:=1 to 23 do begin
            if copy(Content,7,3)=Copy(Polozky[i],1,3) then
               posun:=i;
        end;
     end;
     Poloha:=posun;
     if Poloha<1 then
        Poloha:=1;
     If Poloha>23 then
        Poloha:=23;

     Response.SetCustomHeader('Content-Type','text/html');
     Response.Content:=ZobrazStranku(Poloha);
end;

function TWebModule1.ZobrazStranku(pozice:integer):string;
var i:integer;
    stranka:string;
begin
     stranka:='<html><head><title>V.O.D. - '+Polozky[pozice]+'</title></head><body background="/cgi-bin/images/background.gif">';
//     stranka:='<html><head><title>'+Request.Content+'</title></head><body background="images/background.gif">';
     for i:=1 to Pocty[pozice] do
         stranka:=stranka+
                       '<font color=#00f000><h2><center>'+Polozky[pozice]+' '+Cisla[i]+'</center></h2></font>'+
                       '<center><img src="/cgi-bin/images/'+Obrazky[pozice]+inttostr(i)+'.gif"></center>'+
                       '<br>'+
                       '<center><font color=#ffff00><strong>Cena: </strong></font><font color=#f0f0ff>'+inttostr(Cena[pozice,i])+' Kc</font></center>'+
                       '<hr>';
     stranka:=stranka+
                       '<form method="POST" action="/cgi-bin/DiplomkaCGI.exe/VhoditDoKosiku">'+
	               '<p><center><font color=#ff00ff>Druh zbozi </font><select name="zbozi" size="1">';
     for i:=1 to Pocty[pozice] do
         stranka:=stranka+
	               '<option>'+Polozky[pozice]+' '+Cisla[i]+'</option>';
     stranka:=stranka+
	               '</select></center></p>'+
                       '<p><center><font color=#ff00ff>Pocet kusu </font><input type="text" name="pocet" maxlength=5 size=5 value="1"></center></p>'+
 	               '<p><center><input type="submit" name="kosik" value="Vhodit do kosiku"></center></p>'+
                       '</form>'+'<hr>'+
                       '<table width=100%>'+'<tr>';

     if pozice=1 then
        stranka:=stranka+
                       '<td align=left width=30%></td>'
     else
        stranka:=stranka+
                       '<td align=left width=30%><form method="POST" action="/cgi-bin/DiplomkaCGI.exe"><p><input type="SUBMIT" name="posun" value="'+Polozky[pozice-1]+'"></p></form></td>';

     stranka:=stranka+
                       '<td align=center width=40%><form method="POST" action="/cgi-bin/DiplomkaCGI.exe/InformaceOKosiku"><p><input type="SUBMIT" name="posun" value="Nkupn kok"></p></form></td>';

     if pozice=23 then
        stranka:=stranka+
                       '<td align=left width=30%></td>'
     else
        stranka:=stranka+
                       '<td align=right width=30%><form method="POST" action="/cgi-bin/DiplomkaCGI.exe"><p><input type="SUBMIT" name="posun" value="'+Polozky[pozice+1]+'"></p></form></td>';

     stranka:=stranka+
                       '</tr>'+'</table>'+
                       '<hr><center><font size=-2 color=#ffffff>Privateer 2 is registered trademark of ORIGIN</font></center>'+
                       '</body></html>';
     Result:=stranka;
end;

function TWebModule1.ZrusPrebytecne(Contents: TStringList):boolean;
var i,j:integer;
begin
     Result:=False;
        for i:=0 to (Contents.Count-1) div 3 do begin
            for j:=i+1 to (Contents.Count-1) div 3 do begin
                if Contents.Strings[i*3]=Contents.Strings[j*3] then begin
                   Contents.Strings[i*3+1]:=inttostr(strtoint(Contents.Strings[i*3+1])+strtoint(Contents.Strings[j*3+1]));
                   Contents.Strings[i*3+2]:=inttostr(strtoint(Contents.Strings[i*3+2])+strtoint(Contents.Strings[j*3+2]));
                   Contents.Delete(j*3);
                   Contents.Delete(j*3+1);
                   Contents.Delete(j*3+2);
                   Result:=True;
                   break;
                end;
            end;
        end;
end;

procedure TWebModule1.WebModule1WebActionItem3Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var Contents:TStringList;
    i,j,pozice,celkem:integer;
    FileName:string;
begin
     Response.SetCustomHeader('Content-Type','text/html');
     FileName:='Hosts\'+Request.Host;
     Contents:=TStringList.Create;
     try
        if FileExists(FileName)=True then begin
           Contents.LoadFromFile(FileName);
           Response.Content:='<html><head><title>V.O.D. - Nkupn kok</title></head><body background="/cgi-bin/images/background.gif">'+
                          '<h2><font color=#ff00ff>V nkupn kok obsahuje:</font></h2>'+
                          '<form method="POST" action="/cgi-bin/DiplomkaCGI.exe/VymazKosik">'+
                          '<table width=100%><tr><i><b>'+
                          '<td align=center width=15%><font color=#00ff00>Ozna.</font></td>'+
                          '<td align=left width=60%><font color=#00ff00>Nzev zbo</font></td>'+
                          '<td align=center width=10%><font color=#00ff00>Mnostv</font></td>'+
                          '<td align=right width=15%><font color=#00ff00>Cena</font></td></b></i></tr>';
           celkem:=0;
           for i:=0 to (Contents.Count-1) div 3 do begin
               Response.Content:=Response.Content+
                          '<tr><td align=center><input type=checkbox name="'+inttohex(i,4)+'" value="yes"></td>'+
                          '<td align=left><font color=#ffff00>'+Contents.Strings[i*3]+'</font></td>'+
                          '<td align=center><font color=#f0f0f0>'+Contents.Strings[i*3+1]+'<font></td>'+
                          '<td align=right><font color=#ff00aa>'+Contents.Strings[i*3+2]+' K</font></td></tr>';
               celkem:=celkem+strtoint(Contents.Strings[i*3+2]);
           end;
           Response.Content:=Response.Content+
                          '<tr><td></td><td></td>'+
                          '<td align=right><font color=#00ffff><b>Cena celkem</b></font></td>'+
                          '<td align=right><font color=#00ffff><b>'+inttostr(celkem)+' K</b></font></td></tr>'+
                          '</table><hr>'+'<table width=100%>'+
                          '<tr><td width=40% align=left><p><input type="SUBMIT" name="vyhod" value="Vyhodit z koku"></p></td></form>'+
                          '<td width=20% align=center><form method="POST" action="/cgi-bin/DiplomkaCGI.exe"><p><input type="SUBMIT" name="zpet" value="Zpt..."></p></form></td>'+
                          '<td width=40% align=right><form method="POST" action="/cgi-bin/DiplomkaCGI.exe/PlatitSETem"><p><input type="SUBMIT" name="zaplat" value="Zaplatit nkup"></p></form></td></tr></table>'+
                          '</body></html>';
        end else begin
           Response.Content:='<html><head><title>V.O.D. - Nkupn kok</title></head><body background="/cgi-bin/images/background.gif">'+
                          '<h2><font color=#ff00ff>V nkupn kok je przdn...</font></h2>'+
                          '<center><form method="POST" action="'+copy(Request.URL,1,length(Request.URL))+'"><p><input type="SUBMIT" name="zpet" value="Zpt ..."></p></form></center>'+
                          '</body></html>';
        end;
     finally
        Contents.Free;
     end;
end;

procedure TWebModule1.WebModule1WebActionItem4Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var Contents,Soubor:TStringList;
    i,id,vymazan:integer;
    FileName:string;
begin
     vymazan:=0;
     Response.SetCustomHeader('Content-Type','text/html');
     FileName:='Hosts\'+Request.Host;
     Contents:=TStringList.Create;
     try
        Request.ExtractContentFields(Contents);
        Soubor:=TStringList.Create;
        try
           Soubor.LoadFromFile(FileName);
           for i:=0 to (Contents.Count-2) do begin
               if copy(Contents.Strings[i],6,3)='yes' then begin
                  id:=strtoint('$'+copy(Contents.Strings[i],1,4))-i;
                  Soubor.Delete(id*3);
                  Soubor.Delete(id*3);
                  Soubor.Delete(id*3);
               end;
           end;
           if Soubor.Count<>0 then
              Soubor.SaveToFile(FileName)
           else
              DeleteFile(FileName);
        finally
           Soubor.Free;
        end;
     finally
        Contents.Free;
     end;
     WebModule1WebActionItem3Action(Sender,Request,Response,Handled);
end;

procedure TWebModule1.WebModule1WebActionItem5Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var Soubor:TStringList;
    i:integer;
    FileName:string;
    IP:string;
begin
     FileName:='Hosts\'+Request.Host;
     IP:=LocalIP;
     Soubor:=TStringList.Create;
     try
        Soubor.LoadFromFile(FileName);
        Response.Content:='Mime version: 1.0'+#13#10+
                          'Content-Type: text/plain'+#13#10+
                          'Content-Length: 0'+#13#10+
                          'Content-Transfer-Encoding: binary'+#13#10+
                          'SET-Initiation-Type: Payment'+#13#10+
                          'SET-Version: 0.0'+#13#10+
                          'SET-SET-URL: http://'+IP+'/cgi-bin/DiplomkaCGI.exe/PlatitSETem'+#13#10+
                          'SET-Success-URL: http://'+IP+'/cgi-bin/DiplomkaCGI.exe/Uspech'+#13#10+
                          #13#10;
        for i:=0 to (Soubor.Count-1)div 3 do begin
            Response.Content:=Response.Content+
                          Soubor.Strings[i*3]+';'+Soubor.Strings[i*3+1]+';'+Soubor.Strings[i*3+2]+#13#10;
        end;
     finally
        Soubor.Free;
     end;

end;

function TwebModule1.LocalIP : string;
type
    TaPInAddr = array [0..10] of PInAddr;
    PaPInAddr = ^TaPInAddr;
var
    phe  : PHostEnt;
    pptr : PaPInAddr;
    Buffer : array [0..63] of char;
    I    : Integer;
    GInitData      : TWSADATA;
begin
    WSAStartup($101, GInitData);
    Result := '';
    GetHostName(Buffer, SizeOf(Buffer));
    phe :=GetHostByName(buffer);
    if phe = nil then Exit;
    pptr := PaPInAddr(Phe^.h_addr_list);
    I := 0;
    while pptr^[I] <> nil do begin
      result:=StrPas(inet_ntoa(pptr^[I]^));
      Inc(I);
    end;
    WSACleanup;
end;


procedure TWebModule1.WebModule1WebActionItem6Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
     Response.SetCustomHeader('Content-Type','text/html');
     Response.Content:='<html><head><title>V.O.D - Proveden platby</title></head><body background="/cgi-bin/images/background.gif">'+
                       '<center><h2><font color=#ff00ff>Vae platba SETem byla spn provedena...</font></h2></center>'+
                       '<center><form method="POST" action="/cgi-bin/DiplomkaCGI.exe"><p><input type="SUBMIT" name="zpet" value="Zpt..."></p></form></center></body></html>';

end;

end.
